unit CustomDrawnPanel;

{$mode objfpc}{$H+}

// 2021-10-17

interface

uses
  Interfaces,
  //Windows,
  LCLType,
  Classes, ExtCtrls, SysUtils, Graphics;

type
  TCustomDrawnPanel = class(TPanel)
    protected
      procedure Paint; override;
    public
      constructor Create(TheOwner: TComponent); override;
  end;


implementation


constructor TCustomDrawnPanel.Create(TheOwner: TComponent); //override;
begin
  inherited;
  Self.Width  := 110;
  Self.Height := 100;
end;

procedure TCustomDrawnPanel.Paint; //override;
const
  Left1   =  3;
  Top1    =  3;
  Height1 = 20;
  Width1  = 20;
begin
  // This panel will show up as coded only on Run Time
  if (csDesigning in ComponentState)
  then inherited Paint
  else
    begin
      //not inherited;

      // draw two frames, testwise ..
      Self.Canvas.Pen.Color:= clBlack;
      Self.Canvas.Brush.Color:= clWhite;
      Self.Canvas.Rectangle( 0, 0, Self.ClientWidth, Self.ClientHeight div 2 -1);
      Self.Canvas.Rectangle( 0, Self.ClientHeight div 2 +1, Self.ClientWidth, Self.ClientHeight);

      // draw Squares
      Self.Canvas.Pen.Color:= clBlack;
      Self.Canvas.Brush.Color:= clYellow;
      Self.Canvas.Rectangle( Left1  +0,  Top1,  Left1 +Width1  +0,  Top1 +Height1);
      Self.Canvas.Brush.Color:= clBlue;
      Self.Canvas.Rectangle( Left1 +25,  Top1,  Left1 +Width1 +25,  Top1 +Height1);
      Self.Canvas.Brush.Color:= clRed;
      Self.Canvas.Rectangle( Left1 +50,  Top1,  Left1 +Width1 +50,  Top1 +Height1);

      // draw more Squares ..
      Self.Canvas.Pen.Color:= clTeal;
      Self.Canvas.Brush.Color:= clYellow;
      Self.Canvas.Rectangle( Left1  +0,  Top1 +22,  Left1 +Width1  +0,  Top1 +42);
      Self.Canvas.Brush.Color:= clBlue;
      Self.Canvas.Rectangle( Left1 +25,  Top1 +22,  Left1 +Width1 +25,  Top1 +42);
      Self.Canvas.Brush.Color:= clRed;
      Self.Canvas.Rectangle( Left1 +50,  Top1 +22,  Left1 +Width1 +50,  Top1 +42);

      // draw text
      Self.Canvas.Brush.Style:= bsClear;
      Self.Canvas.Font.Size:= 16;
      Self.Canvas.TextOut( 10, 58, 'Test-Text');
    end;
end;


end.

